"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _MaterialComponent6 = require("../MaterialComponent");

var _MaterialComponent7 = _interopRequireDefault(_MaterialComponent6);

var _Button2 = require("../Button");

var _Button3 = _interopRequireDefault(_Button2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Card = function (_MaterialComponent) {
  _inherits(Card, _MaterialComponent);

  function Card() {
    _classCallCheck(this, Card);

    var _this = _possibleConstructorReturn(this, (Card.__proto__ || Object.getPrototypeOf(Card)).call(this));

    _this.componentName = "card";
    _this._mdcProps = ["theme-dark"];
    return _this;
  }

  return Card;
}(_MaterialComponent7.default);

var CardSection = function (_MaterialComponent2) {
  _inherits(CardSection, _MaterialComponent2);

  function CardSection() {
    _classCallCheck(this, CardSection);

    var _this2 = _possibleConstructorReturn(this, (CardSection.__proto__ || Object.getPrototypeOf(CardSection)).call(this));

    _this2.componentName = "";
    return _this2;
  }

  _createClass(CardSection, [{
    key: "materialDom",
    value: function materialDom(props) {
      return React.createElement(
        "section",
        props,
        props.children
      );
    }
  }]);

  return CardSection;
}(_MaterialComponent7.default);

var CardPrimary = function (_CardSection) {
  _inherits(CardPrimary, _CardSection);

  function CardPrimary() {
    _classCallCheck(this, CardPrimary);

    var _this3 = _possibleConstructorReturn(this, (CardPrimary.__proto__ || Object.getPrototypeOf(CardPrimary)).call(this));

    _this3.componentName = "card__primary";
    return _this3;
  }

  return CardPrimary;
}(CardSection);

var CardSupportingText = function (_CardSection2) {
  _inherits(CardSupportingText, _CardSection2);

  function CardSupportingText() {
    _classCallCheck(this, CardSupportingText);

    var _this4 = _possibleConstructorReturn(this, (CardSupportingText.__proto__ || Object.getPrototypeOf(CardSupportingText)).call(this));

    _this4.componentName = "card__supporting-text";
    return _this4;
  }

  return CardSupportingText;
}(CardSection);

var CardActions = function (_CardSection3) {
  _inherits(CardActions, _CardSection3);

  function CardActions() {
    _classCallCheck(this, CardActions);

    var _this5 = _possibleConstructorReturn(this, (CardActions.__proto__ || Object.getPrototypeOf(CardActions)).call(this));

    _this5.componentName = "card__actions";
    _this5._mdcProps = ["vertical"];
    return _this5;
  }

  return CardActions;
}(CardSection);

var CardMedia = function (_CardSection4) {
  _inherits(CardMedia, _CardSection4);

  function CardMedia() {
    _classCallCheck(this, CardMedia);

    var _this6 = _possibleConstructorReturn(this, (CardMedia.__proto__ || Object.getPrototypeOf(CardMedia)).call(this));

    _this6.componentName = "card__media";
    return _this6;
  }

  return CardMedia;
}(CardSection);

var CardAction = function (_Button) {
  _inherits(CardAction, _Button);

  function CardAction() {
    _classCallCheck(this, CardAction);

    var _this7 = _possibleConstructorReturn(this, (CardAction.__proto__ || Object.getPrototypeOf(CardAction)).call(this));

    _this7.componentName = "card__action";
    return _this7;
  }

  _createClass(CardAction, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this8 = this;

      return React.createElement(
        "button",
        _extends({
          className: "mdc-button mdc-button--compact"
        }, props, {
          ref: function ref(control) {
            _this8.control = control;
          }
        }),
        props.children
      );
    }
  }]);

  return CardAction;
}(_Button3.default);

var CardTitle = function (_MaterialComponent3) {
  _inherits(CardTitle, _MaterialComponent3);

  function CardTitle() {
    _classCallCheck(this, CardTitle);

    var _this9 = _possibleConstructorReturn(this, (CardTitle.__proto__ || Object.getPrototypeOf(CardTitle)).call(this));

    _this9.componentName = "card__title";
    _this9._mdcProps = ["large"];
    return _this9;
  }

  _createClass(CardTitle, [{
    key: "materialDom",
    value: function materialDom(props) {
      return React.createElement(
        "h1",
        props,
        props.children
      );
    }
  }]);

  return CardTitle;
}(_MaterialComponent7.default);

var CardSubtitle = function (_MaterialComponent4) {
  _inherits(CardSubtitle, _MaterialComponent4);

  function CardSubtitle() {
    _classCallCheck(this, CardSubtitle);

    var _this10 = _possibleConstructorReturn(this, (CardSubtitle.__proto__ || Object.getPrototypeOf(CardSubtitle)).call(this));

    _this10.componentName = "card__subtitle";
    return _this10;
  }

  _createClass(CardSubtitle, [{
    key: "materialDom",
    value: function materialDom(props) {
      return React.createElement(
        "h2",
        props,
        props.children
      );
    }
  }]);

  return CardSubtitle;
}(_MaterialComponent7.default);

var CardHorizontalBlock = function (_CardSection5) {
  _inherits(CardHorizontalBlock, _CardSection5);

  function CardHorizontalBlock() {
    _classCallCheck(this, CardHorizontalBlock);

    var _this11 = _possibleConstructorReturn(this, (CardHorizontalBlock.__proto__ || Object.getPrototypeOf(CardHorizontalBlock)).call(this));

    _this11.componentName = "card__horizontal-block";
    return _this11;
  }

  return CardHorizontalBlock;
}(CardSection);

var CardMediaItem = function (_MaterialComponent5) {
  _inherits(CardMediaItem, _MaterialComponent5);

  function CardMediaItem() {
    _classCallCheck(this, CardMediaItem);

    var _this12 = _possibleConstructorReturn(this, (CardMediaItem.__proto__ || Object.getPrototypeOf(CardMediaItem)).call(this));

    _this12.componentName = "card__media-item";
    _this12._mdcProps = [];
    return _this12;
  }

  _createClass(CardMediaItem, [{
    key: "materialDom",
    value: function materialDom(props) {
      var className = "";
      if (props.x) {
        className = "mdc-card__media-item--" + props.x + "x";
      }
      return React.createElement("img", _extends({ className: className }, props));
    }
  }]);

  return CardMediaItem;
}(_MaterialComponent7.default);

Card.Primary = CardPrimary;
Card.SupportingText = CardSupportingText;
Card.Actions = CardActions;
Card.Action = CardAction;
Card.Media = CardMedia;
Card.Title = CardTitle;
Card.Subtitle = CardSubtitle;
Card.HorizontalBlock = CardHorizontalBlock;
Card.MediaItem = CardMediaItem;

exports.default = Card;