"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _MaterialComponent5 = require("../MaterialComponent");

var _MaterialComponent6 = _interopRequireDefault(_MaterialComponent5);

var _dialog = require("@material/dialog/");

var _Button2 = require("../Button");

var _Button3 = _interopRequireDefault(_Button2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 */
var Dialog = function (_MaterialComponent) {
  _inherits(Dialog, _MaterialComponent);

  function Dialog() {
    _classCallCheck(this, Dialog);

    var _this = _possibleConstructorReturn(this, (Dialog.__proto__ || Object.getPrototypeOf(Dialog)).call(this));

    _this.componentName = "dialog";
    _this._onAccept = _this._onAccept.bind(_this);
    _this._onCancel = _this._onCancel.bind(_this);
    return _this;
  }

  _createClass(Dialog, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.MDComponent = new _dialog.MDCDialog(this.control);
      this.MDComponent.listen("MDCDialog:accept", this._onAccept);
      this.MDComponent.listen("MDCDialog:cancel", this._onCancel);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.MDComponent.unlisten("MDCDialog:accept", this._onAccept);
      this.MDComponent.unlisten("MDCDialog:cancel", this._onCancel);
      this.MDComponent.destroy && this.MDComponent.destroy();
    }
  }, {
    key: "_onAccept",
    value: function _onAccept(e) {
      if (this.props.onAccept) {
        this.props.onAccept(e);
      }
    }
  }, {
    key: "_onCancel",
    value: function _onCancel(e) {
      if (this.props.onCancel) {
        this.props.onCancel(e);
      }
    }
  }, {
    key: "materialDom",
    value: function materialDom(props) {
      var _this2 = this;

      return React.createElement(
        "aside",
        _extends({
          role: "alertdialog",
          ref: function ref(control) {
            _this2.control = control;
          }
        }, props),
        React.createElement(
          "div",
          { className: "mdc-dialog__surface" },
          props.children
        ),
        React.createElement("div", { className: "mdc-dialog__backdrop" })
      );
    }
  }]);

  return Dialog;
}(_MaterialComponent6.default);

var DialogHeader = function (_MaterialComponent2) {
  _inherits(DialogHeader, _MaterialComponent2);

  function DialogHeader() {
    _classCallCheck(this, DialogHeader);

    var _this3 = _possibleConstructorReturn(this, (DialogHeader.__proto__ || Object.getPrototypeOf(DialogHeader)).call(this));

    _this3.componentName = "dialog__header";
    return _this3;
  }

  _createClass(DialogHeader, [{
    key: "materialDom",
    value: function materialDom(props) {
      return React.createElement(
        "header",
        props,
        React.createElement(
          "h2",
          { className: "mdc-dialog__header__title" },
          props.children
        )
      );
    }
  }]);

  return DialogHeader;
}(_MaterialComponent6.default);

/**
 * @prop scrollable = false
 */


var DialogBody = function (_MaterialComponent3) {
  _inherits(DialogBody, _MaterialComponent3);

  function DialogBody() {
    _classCallCheck(this, DialogBody);

    var _this4 = _possibleConstructorReturn(this, (DialogBody.__proto__ || Object.getPrototypeOf(DialogBody)).call(this));

    _this4.componentName = "dialog__body";
    _this4._mdcProps = ["scrollable"];
    return _this4;
  }

  _createClass(DialogBody, [{
    key: "materialDom",
    value: function materialDom(props) {
      return React.createElement(
        "section",
        props,
        props.children
      );
    }
  }]);

  return DialogBody;
}(_MaterialComponent6.default);

var DialogFooter = function (_MaterialComponent4) {
  _inherits(DialogFooter, _MaterialComponent4);

  function DialogFooter() {
    _classCallCheck(this, DialogFooter);

    var _this5 = _possibleConstructorReturn(this, (DialogFooter.__proto__ || Object.getPrototypeOf(DialogFooter)).call(this));

    _this5.componentName = "dialog__footer";
    return _this5;
  }

  _createClass(DialogFooter, [{
    key: "materialDom",
    value: function materialDom(props) {
      return React.createElement(
        "footer",
        props,
        props.children
      );
    }
  }]);

  return DialogFooter;
}(_MaterialComponent6.default);

/**
 * @prop cancel = false
 * @prop accept = false
 */


var DialogFooterButton = function (_Button) {
  _inherits(DialogFooterButton, _Button);

  function DialogFooterButton() {
    _classCallCheck(this, DialogFooterButton);

    var _this6 = _possibleConstructorReturn(this, (DialogFooterButton.__proto__ || Object.getPrototypeOf(DialogFooterButton)).call(this));

    _this6.componentName = "dialog__footer__button";
    _this6._mdcProps = ["cancel", "accept"];
    return _this6;
  }

  _createClass(DialogFooterButton, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this7 = this;

      return React.createElement(
        "button",
        _extends({}, props, {
          className: "mdc-button",
          ref: function ref(control) {
            _this7.control = control;
          }
        }),
        props.children
      );
    }
  }]);

  return DialogFooterButton;
}(_Button3.default);

Dialog.Header = DialogHeader;
Dialog.Body = DialogBody;
Dialog.Footer = DialogFooter;
Dialog.FooterButton = DialogFooterButton;

exports.default = Dialog;