"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _MaterialComponent8 = require("../MaterialComponent");

var _MaterialComponent9 = _interopRequireDefault(_MaterialComponent8);

var _temporary = require("@material/drawer/temporary");

var _persistent = require("@material/drawer/persistent");

var _List = require("../List");

var _List2 = _interopRequireDefault(_List);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TemporaryDrawer = function (_MaterialComponent) {
  _inherits(TemporaryDrawer, _MaterialComponent);

  function TemporaryDrawer() {
    _classCallCheck(this, TemporaryDrawer);

    var _this = _possibleConstructorReturn(this, (TemporaryDrawer.__proto__ || Object.getPrototypeOf(TemporaryDrawer)).call(this));

    _this.componentName = "temporary-drawer";
    _this._open = _this._open.bind(_this);
    _this._close = _this._close.bind(_this);
    return _this;
  }

  _createClass(TemporaryDrawer, [{
    key: "_open",
    value: function _open() {
      if (this.props.onOpen) {
        this.props.onOpen();
      }
    }
  }, {
    key: "_close",
    value: function _close() {
      if (this.props.onClose) {
        this.props.onClose();
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.MDComponent = _temporary.MDCTemporaryDrawer.attachTo(this.control);
      this.MDComponent.listen("MDCTemporaryDrawer:open", this._open);
      this.MDComponent.listen("MDCTemporaryDrawer:close", this._close);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.MDComponent.unlisten("MDCTemporaryDrawer:close", this._close);
      this.MDComponent.unlisten("MDCTemporaryDrawer:open", this._open);
      this.MDComponent.destroy && this.MDComponent.destroy();
    }
  }, {
    key: "materialDom",
    value: function materialDom(props) {
      var _this2 = this;

      return React.createElement(
        "aside",
        _extends({
          className: "mdc-typography",
          ref: function ref(control) {
            _this2.control = control;
          }
        }, props),
        React.createElement(
          "nav",
          { className: "mdc-temporary-drawer__drawer" },
          props.children
        )
      );
    }
  }]);

  return TemporaryDrawer;
}(_MaterialComponent9.default);

var TemporaryDrawerHeader = function (_MaterialComponent2) {
  _inherits(TemporaryDrawerHeader, _MaterialComponent2);

  function TemporaryDrawerHeader() {
    _classCallCheck(this, TemporaryDrawerHeader);

    var _this3 = _possibleConstructorReturn(this, (TemporaryDrawerHeader.__proto__ || Object.getPrototypeOf(TemporaryDrawerHeader)).call(this));

    _this3.componentName = "temporary-drawer__header";
    return _this3;
  }

  _createClass(TemporaryDrawerHeader, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this4 = this;

      return React.createElement(
        "header",
        _extends({
          ref: function ref(control) {
            _this4.control = control;
          }
        }, props),
        React.createElement(
          "div",
          { className: "mdc-temporary-drawer__header-content" },
          props.children
        )
      );
    }
  }]);

  return TemporaryDrawerHeader;
}(_MaterialComponent9.default);

var TemporaryDrawerContent = function (_MaterialComponent3) {
  _inherits(TemporaryDrawerContent, _MaterialComponent3);

  function TemporaryDrawerContent() {
    _classCallCheck(this, TemporaryDrawerContent);

    var _this5 = _possibleConstructorReturn(this, (TemporaryDrawerContent.__proto__ || Object.getPrototypeOf(TemporaryDrawerContent)).call(this));

    _this5.componentName = "temporary-drawer__content";
    return _this5;
  }

  _createClass(TemporaryDrawerContent, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this6 = this;

      return React.createElement(
        "nav",
        _extends({
          className: "mdc-list",
          ref: function ref(control) {
            _this6.control = control;
          }
        }, props),
        props.children
      );
    }
  }]);

  return TemporaryDrawerContent;
}(_MaterialComponent9.default);

/**
 * @prop spacer = false
 */


var PermanentDrawer = function (_MaterialComponent4) {
  _inherits(PermanentDrawer, _MaterialComponent4);

  function PermanentDrawer() {
    _classCallCheck(this, PermanentDrawer);

    var _this7 = _possibleConstructorReturn(this, (PermanentDrawer.__proto__ || Object.getPrototypeOf(PermanentDrawer)).call(this));

    _this7.componentName = "permanent-drawer";
    return _this7;
  }

  _createClass(PermanentDrawer, [{
    key: "materialDom",
    value: function materialDom(props) {
      return React.createElement(
        "nav",
        _extends({ className: "mdc-typography" }, props),
        props.spacer && React.createElement("div", { className: "mdc-permanent-drawer__toolbar-spacer" }),
        React.createElement(
          "div",
          { className: "mdc-permanent-drawer__content" },
          React.createElement(
            "nav",
            { className: "mdc-list" },
            props.children
          )
        )
      );
    }
  }]);

  return PermanentDrawer;
}(_MaterialComponent9.default);

var PermanentDrawerHeader = function (_MaterialComponent5) {
  _inherits(PermanentDrawerHeader, _MaterialComponent5);

  function PermanentDrawerHeader() {
    _classCallCheck(this, PermanentDrawerHeader);

    var _this8 = _possibleConstructorReturn(this, (PermanentDrawerHeader.__proto__ || Object.getPrototypeOf(PermanentDrawerHeader)).call(this));

    _this8.componentName = "permanent-drawer__header";
    return _this8;
  }

  _createClass(PermanentDrawerHeader, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this9 = this;

      return React.createElement(
        "header",
        _extends({
          ref: function ref(control) {
            _this9.control = control;
          }
        }, props),
        React.createElement(
          "div",
          { className: "mdc-permanent-drawer__header-content" },
          props.children
        )
      );
    }
  }]);

  return PermanentDrawerHeader;
}(_MaterialComponent9.default);

var PermanentDrawerContent = function (_TemporaryDrawerConte) {
  _inherits(PermanentDrawerContent, _TemporaryDrawerConte);

  function PermanentDrawerContent() {
    _classCallCheck(this, PermanentDrawerContent);

    var _this10 = _possibleConstructorReturn(this, (PermanentDrawerContent.__proto__ || Object.getPrototypeOf(PermanentDrawerContent)).call(this));

    _this10.componentName = "permanent-drawer__content";
    return _this10;
  }

  return PermanentDrawerContent;
}(TemporaryDrawerContent);

var PersistentDrawer = function (_MaterialComponent6) {
  _inherits(PersistentDrawer, _MaterialComponent6);

  function PersistentDrawer() {
    _classCallCheck(this, PersistentDrawer);

    var _this11 = _possibleConstructorReturn(this, (PersistentDrawer.__proto__ || Object.getPrototypeOf(PersistentDrawer)).call(this));

    _this11.componentName = "persistent-drawer";
    _this11._open = _this11._open.bind(_this11);
    _this11._close = _this11._close.bind(_this11);
    return _this11;
  }

  _createClass(PersistentDrawer, [{
    key: "_open",
    value: function _open() {
      if (this.props.onOpen) {
        this.props.onOpen();
      }
    }
  }, {
    key: "_close",
    value: function _close() {
      if (this.props.onClose) {
        this.props.onClose();
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.MDComponent = _persistent.MDCPersistentDrawer.attachTo(this.control);
      this.MDComponent.listen("MDCPersistentDrawer:open", this._open);
      this.MDComponent.listen("MDCPersistentDrawer:close", this._close);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.MDComponent.unlisten("MDCPersistentDrawer:close", this._close);
      this.MDComponent.unlisten("MDCPersistentDrawer:open", this._open);
      this.MDComponent.destroy && this.MDComponent.destroy();
    }
  }, {
    key: "materialDom",
    value: function materialDom(props) {
      var _this12 = this;

      return React.createElement(
        "aside",
        _extends({
          className: "mdc-typography",
          ref: function ref(control) {
            _this12.control = control;
          }
        }, props),
        React.createElement("nav", { className: "mdc-persistent-drawer__drawer" })
      );
    }
  }]);

  return PersistentDrawer;
}(_MaterialComponent9.default);

var PersistentDrawerHeader = function (_MaterialComponent7) {
  _inherits(PersistentDrawerHeader, _MaterialComponent7);

  function PersistentDrawerHeader() {
    _classCallCheck(this, PersistentDrawerHeader);

    var _this13 = _possibleConstructorReturn(this, (PersistentDrawerHeader.__proto__ || Object.getPrototypeOf(PersistentDrawerHeader)).call(this));

    _this13.componentName = "persistent-drawer__header";
    return _this13;
  }

  _createClass(PersistentDrawerHeader, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this14 = this;

      return React.createElement(
        "header",
        _extends({
          ref: function ref(control) {
            _this14.control = control;
          }
        }, props),
        React.createElement(
          "div",
          { className: "mdc-persistent-drawer__header-content" },
          props.children
        )
      );
    }
  }]);

  return PersistentDrawerHeader;
}(_MaterialComponent9.default);

var PersistentDrawerContent = function (_TemporaryDrawerConte2) {
  _inherits(PersistentDrawerContent, _TemporaryDrawerConte2);

  function PersistentDrawerContent() {
    _classCallCheck(this, PersistentDrawerContent);

    var _this15 = _possibleConstructorReturn(this, (PersistentDrawerContent.__proto__ || Object.getPrototypeOf(PersistentDrawerContent)).call(this));

    _this15.componentName = "persistent-drawer__content";
    return _this15;
  }

  return PersistentDrawerContent;
}(TemporaryDrawerContent);

/**
 * @prop selected = false
 */


var DrawerItem = function (_List$LinkItem) {
  _inherits(DrawerItem, _List$LinkItem);

  function DrawerItem() {
    _classCallCheck(this, DrawerItem);

    return _possibleConstructorReturn(this, (DrawerItem.__proto__ || Object.getPrototypeOf(DrawerItem)).call(this));
  }

  _createClass(DrawerItem, [{
    key: "materialDom",
    value: function materialDom(props) {
      var returnedNode = _get(DrawerItem.prototype.__proto__ || Object.getPrototypeOf(DrawerItem.prototype), "materialDom", this).call(this, props);
      /* Logic to add selected class */
      if (props.selected) {
        returnedNode.attributes["className"] = "mdc-temporary-drawer--selected mdc-permanent-drawer--selected";
      }
      return returnedNode;
    }
  }]);

  return DrawerItem;
}(_List2.default.LinkItem);

var Drawer = {};

Drawer.DrawerItem = DrawerItem;
Drawer.TemporaryDrawer = TemporaryDrawer;
Drawer.TemporaryDrawerHeader = TemporaryDrawerHeader;
Drawer.TemporaryDrawerContent = TemporaryDrawerContent;
Drawer.PermanentDrawer = PermanentDrawer;
Drawer.PermanentDrawerHeader = PermanentDrawerHeader;
Drawer.PermanentDrawerContent = PermanentDrawerContent;
Drawer.PersistentDrawer = PersistentDrawer;
Drawer.PersistentDrawerHeader = PersistentDrawerHeader;
Drawer.PersistentDrawerContent = PersistentDrawerContent;

exports.default = Drawer;