"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _MaterialComponent4 = require("../MaterialComponent");

var _MaterialComponent5 = _interopRequireDefault(_MaterialComponent4);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LayoutGrid = function (_MaterialComponent) {
  _inherits(LayoutGrid, _MaterialComponent);

  function LayoutGrid() {
    _classCallCheck(this, LayoutGrid);

    var _this = _possibleConstructorReturn(this, (LayoutGrid.__proto__ || Object.getPrototypeOf(LayoutGrid)).call(this));

    _this.componentName = "layout-grid";
    return _this;
  }

  _createClass(LayoutGrid, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this2 = this;

      return React.createElement(
        "div",
        _extends({
          ref: function ref(control) {
            _this2.control = control;
          }
        }, props),
        props.children
      );
    }
  }]);

  return LayoutGrid;
}(_MaterialComponent5.default);

var LayoutGridInner = function (_MaterialComponent2) {
  _inherits(LayoutGridInner, _MaterialComponent2);

  function LayoutGridInner() {
    _classCallCheck(this, LayoutGridInner);

    var _this3 = _possibleConstructorReturn(this, (LayoutGridInner.__proto__ || Object.getPrototypeOf(LayoutGridInner)).call(this));

    _this3.componentName = "layout-grid__inner";
    return _this3;
  }

  _createClass(LayoutGridInner, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this4 = this;

      return React.createElement(
        "div",
        _extends({
          ref: function ref(control) {
            _this4.control = control;
          }
        }, props),
        props.children
      );
    }
  }]);

  return LayoutGridInner;
}(_MaterialComponent5.default);

/**
 * @prop cols = 0
 * @prop desktopCols = 0
 * @prop tabletCols = 0
 * @prop phoneCols = 0
 * @prop order = 0
 * @prop align = ''
 */


var LayoutGridCell = function (_MaterialComponent3) {
  _inherits(LayoutGridCell, _MaterialComponent3);

  function LayoutGridCell() {
    _classCallCheck(this, LayoutGridCell);

    var _this5 = _possibleConstructorReturn(this, (LayoutGridCell.__proto__ || Object.getPrototypeOf(LayoutGridCell)).call(this));

    _this5.componentName = "layout-grid__cell";
    _this5._propsDict = {
      cols: "cols",
      desktop: "desktopCols",
      tablet: "tabletCols",
      phone: "phoneCols",
      order: "order",
      align: "align"
    };
    return _this5;
  }

  _createClass(LayoutGridCell, [{
    key: "createClassName",
    value: function createClassName(props) {
      var baseClass = "mdc-layout-grid__cell--";
      var classes = [];

      if (props[this._propsDict.cols]) {
        classes.push(baseClass + "span-" + props[this._propsDict.cols]);
      }

      if (props[this._propsDict.desktop]) {
        classes.push(baseClass + "span-" + props[this._propsDict.desktop] + "-desktop");
      }

      if (props[this._propsDict.tablet]) {
        classes.push(baseClass + "span-" + props[this._propsDict.tablet] + "-tablet");
      }

      if (props[this._propsDict.phone]) {
        classes.push(baseClass + "span-" + props[this._propsDict.phone] + "-phone");
      }

      if (props[this._propsDict.order]) {
        classes.push(baseClass + "order-" + props[this._propsDict.order]);
      }

      if (props[this._propsDict.align]) {
        classes.push(baseClass + "align-" + props[this._propsDict.align]);
      }

      return classes.join(" ");
    }
  }, {
    key: "materialDom",
    value: function materialDom(props) {
      var _this6 = this;

      return React.createElement(
        "div",
        _extends({
          className: this.createClassName(props),
          ref: function ref(control) {
            _this6.control = control;
          }
        }, props),
        props.children
      );
    }
  }, {
    key: "render",
    value: function render() {
      var _this7 = this;

      var element = _get(LayoutGridCell.prototype.__proto__ || Object.getPrototypeOf(LayoutGridCell.prototype), "render", this).call(this);
      // remove the extra attributes used for customising this element - keep the DOM clean
      Object.keys(this._propsDict).forEach(function (key) {
        return delete element.attributes[_this7._propsDict[key]];
      });
      return element;
    }
  }]);

  return LayoutGridCell;
}(_MaterialComponent5.default);

LayoutGrid.Cell = LayoutGridCell;
LayoutGrid.Inner = LayoutGridInner;

exports.default = LayoutGrid;