"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _MaterialComponent7 = require("../MaterialComponent");

var _MaterialComponent8 = _interopRequireDefault(_MaterialComponent7);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @prop dense = false
 * @prop two-line = false
 * @prop interactive = false
 */
var List = function (_MaterialComponent) {
  _inherits(List, _MaterialComponent);

  function List() {
    _classCallCheck(this, List);

    var _this = _possibleConstructorReturn(this, (List.__proto__ || Object.getPrototypeOf(List)).call(this));

    _this.componentName = "list";
    _this._mdcProps = ["dense", "two-line"];
    return _this;
  }

  _createClass(List, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this2 = this;

      if (props.interactive) {
        return React.createElement(
          "nav",
          _extends({ ref: function ref(control) {
              return _this2.control = control;
            } }, props),
          props.children
        );
      }

      return React.createElement(
        "ul",
        _extends({}, props, { ref: function ref(control) {
            return _this2.control = control;
          } }),
        props.children
      );
    }
  }]);

  return List;
}(_MaterialComponent8.default);

var ListItem = function (_MaterialComponent2) {
  _inherits(ListItem, _MaterialComponent2);

  function ListItem() {
    _classCallCheck(this, ListItem);

    var _this3 = _possibleConstructorReturn(this, (ListItem.__proto__ || Object.getPrototypeOf(ListItem)).call(this));

    _this3.componentName = "list-item";
    return _this3;
  }

  _createClass(ListItem, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this4 = this;

      return React.createElement(
        "li",
        _extends({ role: "option" }, props, { ref: function ref(control) {
            return _this4.control = control;
          } }),
        props.children
      );
    }
  }]);

  return ListItem;
}(_MaterialComponent8.default);

var LinkItem = function (_MaterialComponent3) {
  _inherits(LinkItem, _MaterialComponent3);

  function LinkItem() {
    _classCallCheck(this, LinkItem);

    var _this5 = _possibleConstructorReturn(this, (LinkItem.__proto__ || Object.getPrototypeOf(LinkItem)).call(this));

    _this5.componentName = "list-item";
    return _this5;
  }

  _createClass(LinkItem, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      _get(LinkItem.prototype.__proto__ || Object.getPrototypeOf(LinkItem.prototype), "attachRipple", this).call(this);
    }
  }, {
    key: "materialDom",
    value: function materialDom(props) {
      var _this6 = this;

      return React.createElement(
        "a",
        _extends({ role: "option" }, props, { ref: function ref(control) {
            return _this6.control = control;
          } }),
        props.children
      );
    }
  }]);

  return LinkItem;
}(_MaterialComponent8.default);

/**
 * @prop start-detail = true
 * @prop end-detail = false
 */


var ListItemIcon = function (_MaterialComponent4) {
  _inherits(ListItemIcon, _MaterialComponent4);

  function ListItemIcon() {
    _classCallCheck(this, ListItemIcon);

    var _this7 = _possibleConstructorReturn(this, (ListItemIcon.__proto__ || Object.getPrototypeOf(ListItemIcon)).call(this));

    _this7.componentName = "mdc-list-item__icon";
    return _this7;
  }

  _createClass(ListItemIcon, [{
    key: "getProxyClassName",
    value: function getProxyClassName(props) {
      var classNames = [];

      // default behavior
      props["start-detail"] = props["start-detail"] || true;

      // setting class names mutually exclusive
      if (props["end-detail"]) {
        classNames.push("mdc-list-item__end-detail");
      } else if (props["start-detail"]) {
        classNames.push("mdc-list-item__start-detail");
      }
      return classNames.join(" ");
    }
  }, {
    key: "materialDom",
    value: function materialDom(props) {
      var _this8 = this;

      var className = "material-icons " + this.getProxyClassName(props);
      return React.createElement(
        "i",
        _extends({
          className: className,
          "aria-hidden": "true"
        }, props, {
          ref: function ref(control) {
            return _this8.control = control;
          }
        }),
        props.children
      );
    }
  }]);

  return ListItemIcon;
}(_MaterialComponent8.default);

/**
 * @prop start-detail = true
 * @prop end-detail = false
 */


var ListItemAvatar = function (_ListItemIcon) {
  _inherits(ListItemAvatar, _ListItemIcon);

  function ListItemAvatar() {
    _classCallCheck(this, ListItemAvatar);

    var _this9 = _possibleConstructorReturn(this, (ListItemAvatar.__proto__ || Object.getPrototypeOf(ListItemAvatar)).call(this));

    _this9.componentName = "mdc-list-item__avatar";
    return _this9;
  }

  _createClass(ListItemAvatar, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this10 = this;

      return React.createElement("img", _extends({}, props, {
        className: _get(ListItemAvatar.prototype.__proto__ || Object.getPrototypeOf(ListItemAvatar.prototype), "getProxyClassName", this).call(this, props)
      }, props, {
        ref: function ref(control) {
          return _this10.control = control;
        },
        width: props.width || "56",
        height: props.height || "56",
        alt: props.alt || ""
      }));
    }
  }]);

  return ListItemAvatar;
}(ListItemIcon);

var ListDivider = function (_MaterialComponent5) {
  _inherits(ListDivider, _MaterialComponent5);

  function ListDivider() {
    _classCallCheck(this, ListDivider);

    var _this11 = _possibleConstructorReturn(this, (ListDivider.__proto__ || Object.getPrototypeOf(ListDivider)).call(this));

    _this11.componentName = "list-divider";
    _this11._mdcProps = ["inset"];
    return _this11;
  }

  _createClass(ListDivider, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this12 = this;

      return React.createElement("li", _extends({
        role: "separator"
      }, props, {
        ref: function ref(control) {
          return _this12.control = control;
        }
      }));
    }
  }]);

  return ListDivider;
}(_MaterialComponent8.default);

var ListTextContainer = function (_MaterialComponent6) {
  _inherits(ListTextContainer, _MaterialComponent6);

  function ListTextContainer() {
    _classCallCheck(this, ListTextContainer);

    var _this13 = _possibleConstructorReturn(this, (ListTextContainer.__proto__ || Object.getPrototypeOf(ListTextContainer)).call(this));

    _this13.componentName = "list-item__text";
    return _this13;
  }

  _createClass(ListTextContainer, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this14 = this;

      return React.createElement(
        "span",
        _extends({}, props, { ref: function ref(control) {
            return _this14.control = control;
          } }),
        props.children
      );
    }
  }]);

  return ListTextContainer;
}(_MaterialComponent8.default);

var ListPrimaryText = function (_ListTextContainer) {
  _inherits(ListPrimaryText, _ListTextContainer);

  function ListPrimaryText() {
    _classCallCheck(this, ListPrimaryText);

    var _this15 = _possibleConstructorReturn(this, (ListPrimaryText.__proto__ || Object.getPrototypeOf(ListPrimaryText)).call(this));

    _this15.componentName = "list-item__text__primary";
    return _this15;
  }

  return ListPrimaryText;
}(ListTextContainer);

var ListSecondaryText = function (_ListTextContainer2) {
  _inherits(ListSecondaryText, _ListTextContainer2);

  function ListSecondaryText() {
    _classCallCheck(this, ListSecondaryText);

    var _this16 = _possibleConstructorReturn(this, (ListSecondaryText.__proto__ || Object.getPrototypeOf(ListSecondaryText)).call(this));

    _this16.componentName = "list-item__text__secondary";
    return _this16;
  }

  return ListSecondaryText;
}(ListTextContainer);

List.Item = ListItem;
List.LinkItem = LinkItem;
List.ItemIcon = ListItemIcon;
List.ItemAvatar = ListItemAvatar;
List.Divider = ListDivider;
List.TextContainer = ListTextContainer;
List.PrimaryText = ListPrimaryText;
List.SecondaryText = ListSecondaryText;

exports.default = List;