"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _MaterialComponent2 = require("../MaterialComponent");

var _MaterialComponent3 = _interopRequireDefault(_MaterialComponent2);

var _select = require("@material/select/");

var _List = require("../List");

var _List2 = _interopRequireDefault(_List);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = function (_MaterialComponent) {
  _inherits(Select, _MaterialComponent);

  function Select() {
    _classCallCheck(this, Select);

    var _this = _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).call(this));

    _this.componentName = "select";
    _this._mdcProps = ["disabled"];
    _this._changed = _this._changed.bind(_this);
    return _this;
  }

  _createClass(Select, [{
    key: "_changed",
    value: function _changed(e) {
      e = e || {};
      e.selectedIndex = e.selectedIndex || this.MDComponent.selectedIndex;
      e.selectedOptions = e.selectedOptions || this.MDComponent.selectedOptions;
      if (this.props.onChange) {
        this.props.onChange(e);
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!this.props.basic) {
        this.MDComponent = new _select.MDCSelect(this.control);
        this.MDComponent.listen("MDCSelect:change", this._changed);
        this.updateSelection();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (!this.props.basic) {
        this.MDComponent.unlisten("MDCSelect:change", this._changed);
        this.MDComponent.destroy && this.MDComponent.destroy();
      }
    }
  }, {
    key: "updateSelection",
    value: function updateSelection() {
      if ("selectedIndex" in this.props && this.MDComponent) {
        this.MDComponent.selectedIndex = this.props.selectedIndex;
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.updateSelection();
      if (this.MDComponent && this.MDComponent.foundation_) {
        this.MDComponent.foundation_.resize();
      }
    }
  }, {
    key: "materialDom",
    value: function materialDom(props) {
      var _this2 = this;

      if (props.basic) {
        return React.createElement(
          "select",
          _extends({}, props, {
            ref: function ref(control) {
              _this2.control = control;
            }
          }),
          props.children
        );
      }

      return React.createElement(
        "div",
        _extends({
          role: "listbox"
        }, props, {
          ref: function ref(control) {
            _this2.control = control;
          }
        }),
        React.createElement(
          "span",
          { className: "mdc-select__selected-text" },
          props.hintText
        ),
        React.createElement(
          "div",
          { className: "mdc-simple-menu mdc-select__menu" },
          React.createElement(
            "ul",
            { className: "mdc-list mdc-simple-menu__items " },
            props.children
          )
        )
      );
    }
  }]);

  return Select;
}(_MaterialComponent3.default);

Select.Item = _List2.default.Item;

exports.default = Select;