"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _MaterialComponent2 = require("../MaterialComponent");

var _MaterialComponent3 = _interopRequireDefault(_MaterialComponent2);

var _slider = require("@material/slider");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @prop disabled = false
 */
var Slider = function (_MaterialComponent) {
  _inherits(Slider, _MaterialComponent);

  function Slider() {
    _classCallCheck(this, Slider);

    var _this = _possibleConstructorReturn(this, (Slider.__proto__ || Object.getPrototypeOf(Slider)).call(this));

    _this.componentName = "slider";
    _this._mdcProps = [];
    _this._onChange = _this._onChange.bind(_this);
    _this._onInput = _this._onInput.bind(_this);
    return _this;
  }

  _createClass(Slider, [{
    key: "_onChange",
    value: function _onChange() {
      if (this.props.onChange) {
        this.props.onChange(this.MDComponent.value);
      }
    }
  }, {
    key: "_onInput",
    value: function _onInput() {
      if (this.props.onInput) {
        this.props.onInput(this.MDComponent.value);
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.MDComponent = new _slider.MDCSlider(this.base);
      this.MDComponent.listen("MDCSlider:change", this._onChange);
      this.MDComponent.listen("MDCSlider:input", this._onInput);
      this.setValue(); // set initial value programatically because of error if min is greater than initial max
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.MDComponent.unlisten("MDCSlider:change", this._onChange);
      this.MDComponent.unlisten("MDCSlider:input", this._onInput);
      this.MDComponent.destroy && this.MDComponent.destroy();
    }
  }, {
    key: "setValue",
    value: function setValue() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;
      var _props$disabled = props.disabled,
          disabled = _props$disabled === undefined ? false : _props$disabled,
          _props$min = props.min,
          min = _props$min === undefined ? 0 : _props$min,
          _props$max = props.max,
          max = _props$max === undefined ? 100 : _props$max,
          value = props.value,
          step = props.step;

      if (this.MDComponent) {
        if (min > this.MDComponent.max) {
          this.MDComponent.max = max;
          this.MDComponent.min = min;
        } else {
          this.MDComponent.min = min;
          this.MDComponent.max = max;
        }

        this.MDComponent.value = value;
        this.MDComponent.disabled = disabled;
        this.MDComponent.step = step;
      }
    }
  }, {
    key: "materialDom",
    value: function materialDom(allprops) {
      var _allprops$tabindex = allprops.tabindex,
          tabindex = _allprops$tabindex === undefined ? 0 : _allprops$tabindex,
          props = _objectWithoutProperties(allprops, ["tabindex"]);

      this.setValue(allprops);
      return React.createElement(
        "div",
        _extends({
          tabindex: tabindex,
          role: "slider",
          "aria-label": "Select Value"
        }, props),
        React.createElement(
          "div",
          { "class": "mdc-slider__track-container" },
          React.createElement("div", { "class": "mdc-slider__track" })
        ),
        React.createElement(
          "div",
          { "class": "mdc-slider__thumb-container" },
          React.createElement(
            "svg",
            { "class": "mdc-slider__thumb", width: "21", height: "21" },
            React.createElement("circle", { cx: "10.5", cy: "10.5", r: "7.875" })
          ),
          React.createElement("div", { "class": "mdc-slider__focus-ring" })
        )
      );
    }
  }]);

  return Slider;
}(_MaterialComponent3.default);

exports.default = Slider;