"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _MaterialComponent5 = require("../MaterialComponent");

var _MaterialComponent6 = _interopRequireDefault(_MaterialComponent5);

var _tabs = require("@material/tabs");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @prop indicator-accent = false
 * @prop icon-tab-bar = false
 * @prop icons-with-text = false
 * @prop scroller = false
 */
var Tabs = function (_MaterialComponent) {
  _inherits(Tabs, _MaterialComponent);

  function Tabs() {
    _classCallCheck(this, Tabs);

    var _this = _possibleConstructorReturn(this, (Tabs.__proto__ || Object.getPrototypeOf(Tabs)).call(this));

    _this.componentName = "tab-bar";
    _this._mdcProps = ["indicator-accent", "icon-tab-bar", "icons-with-text", "scroller"];
    return _this;
  }

  _createClass(Tabs, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.MDComponent = new _tabs.MDCTabBar(this.control);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.MDComponent.destroy && this.MDComponent.destroy();
    }
  }, {
    key: "materialDom",
    value: function materialDom(allprops) {
      var _this2 = this;

      var className = allprops.className,
          props = _objectWithoutProperties(allprops, ["className"]);

      if (props.scroller) {
        className = "mdc-tab-bar-scroller__scroll-frame__tabs";
      } else {
        className = "";
      }
      return React.createElement(
        "nav",
        _extends({
          className: className,
          role: "tablist"
        }, props, {
          ref: function ref(control) {
            return _this2.control = control;
          }
        }),
        props.children,
        React.createElement("span", { "class": "mdc-tab-bar__indicator" })
      );
    }
  }]);

  return Tabs;
}(_MaterialComponent6.default);

var TabBarScroller = function (_MaterialComponent2) {
  _inherits(TabBarScroller, _MaterialComponent2);

  function TabBarScroller() {
    _classCallCheck(this, TabBarScroller);

    var _this3 = _possibleConstructorReturn(this, (TabBarScroller.__proto__ || Object.getPrototypeOf(TabBarScroller)).call(this));

    _this3.componentName = "tab-bar-scroller";
    return _this3;
  }

  _createClass(TabBarScroller, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.MDComponent = new _tabs.MDCTabBarScroller(this.control);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.MDComponent.destroy && this.MDComponent.destroy();
    }
  }, {
    key: "materialDom",
    value: function materialDom(props) {
      var _this4 = this;

      return React.createElement(
        "div",
        _extends({}, props, { ref: function ref(control) {
            return _this4.control = control;
          } }),
        React.createElement(
          "div",
          { className: "mdc-tab-bar-scroller__indicator mdc-tab-bar-scroller__indicator--back" },
          React.createElement(
            "a",
            {
              className: "mdc-tab-bar-scroller__indicator__inner material-icons",
              href: "#",
              "aria-label": "scroll back button"
            },
            "navigate_before"
          )
        ),
        React.createElement(
          "div",
          { className: "mdc-tab-bar-scroller__scroll-frame" },
          props.children
        ),
        React.createElement(
          "div",
          { className: "mdc-tab-bar-scroller__indicator mdc-tab-bar-scroller__indicator--forward" },
          React.createElement(
            "a",
            {
              className: "mdc-tab-bar-scroller__indicator__inner material-icons",
              href: "#",
              "aria-label": "scroll forward button"
            },
            "navigate_next"
          )
        )
      );
    }
  }]);

  return TabBarScroller;
}(_MaterialComponent6.default);

/**
 * @prop active = false
 */


var Tab = function (_MaterialComponent3) {
  _inherits(Tab, _MaterialComponent3);

  function Tab() {
    _classCallCheck(this, Tab);

    var _this5 = _possibleConstructorReturn(this, (Tab.__proto__ || Object.getPrototypeOf(Tab)).call(this));

    _this5.componentName = "tab";
    _this5._mdcProps = ["active"];
    return _this5;
  }

  _createClass(Tab, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this6 = this;

      return React.createElement(
        "a",
        _extends({ role: "tab" }, props, { ref: function ref(control) {
            return _this6.control = control;
          } }),
        props.children
      );
    }
  }]);

  return Tab;
}(_MaterialComponent6.default);

var TabIconLabel = function (_MaterialComponent4) {
  _inherits(TabIconLabel, _MaterialComponent4);

  function TabIconLabel() {
    _classCallCheck(this, TabIconLabel);

    var _this7 = _possibleConstructorReturn(this, (TabIconLabel.__proto__ || Object.getPrototypeOf(TabIconLabel)).call(this));

    _this7.componentName = "tab__icon-text";
    return _this7;
  }

  _createClass(TabIconLabel, [{
    key: "materialDom",
    value: function materialDom(props) {
      var _this8 = this;

      return React.createElement(
        "span",
        _extends({}, props, { ref: function ref(control) {
            return _this8.control = control;
          } }),
        props.children
      );
    }
  }]);

  return TabIconLabel;
}(_MaterialComponent6.default);

Tabs.TabBarScroller = TabBarScroller;
Tabs.Tab = Tab;
Tabs.TabIconLabel = TabIconLabel;
exports.default = Tabs;