"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _MaterialComponent4 = require("../MaterialComponent");

var _MaterialComponent5 = _interopRequireDefault(_MaterialComponent4);

var _textfield = require("@material/textfield/");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @prop persistent = false
 * @prop validation-msg = false
 */
var Helptext = function (_MaterialComponent) {
  _inherits(Helptext, _MaterialComponent);

  function Helptext() {
    _classCallCheck(this, Helptext);

    var _this = _possibleConstructorReturn(this, (Helptext.__proto__ || Object.getPrototypeOf(Helptext)).call(this));

    _this.componentName = "textfield-helptext";
    _this._mdcProps = ["persistent", "validation-msg"];
    return _this;
  }

  _createClass(Helptext, [{
    key: "materialDom",
    value: function materialDom(props) {
      return React.createElement(
        "p",
        _extends({}, props, { "aria-hidden": "true" }),
        props.children
      );
    }
  }]);

  return Helptext;
}(_MaterialComponent5.default);

var Label = function (_MaterialComponent2) {
  _inherits(Label, _MaterialComponent2);

  function Label() {
    _classCallCheck(this, Label);

    var _this2 = _possibleConstructorReturn(this, (Label.__proto__ || Object.getPrototypeOf(Label)).call(this));

    _this2.componentName = "textfield__label";
    return _this2;
  }

  _createClass(Label, [{
    key: "materialDom",
    value: function materialDom(props) {
      return React.createElement(
        "label",
        props,
        props.children
      );
    }
  }]);

  return Label;
}(_MaterialComponent5.default);

/**
 * @prop fullwidth = false
 * @prop multiline = false
 * @prop dense = false
 * @prop disabled = false
 * @prop box = false
 * @prop type = 'text'
 * @prop value = ''
 * @prop label = ''
 */


var TextfieldInput = function (_MaterialComponent3) {
  _inherits(TextfieldInput, _MaterialComponent3);

  function TextfieldInput() {
    _classCallCheck(this, TextfieldInput);

    var _this3 = _possibleConstructorReturn(this, (TextfieldInput.__proto__ || Object.getPrototypeOf(TextfieldInput)).call(this));

    _this3.componentName = "textfield";
    _this3._mdcProps = ["fullwidth", "multiline", "dense", "disabled", "box"];
    _this3.state = {
      showFloatingLabel: false
    };
    return _this3;
  }

  _createClass(TextfieldInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this4 = this;

      this.setState({
        showFloatingLabel: true
      }, function () {
        _this4.MDComponent = new _textfield.MDCTextfield(_this4.control);
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.MDComponent && this.MDComponent.destroy && this.MDComponent.destroy();
    }
  }, {
    key: "materialDom",
    value: function materialDom(allprops) {
      var _this5 = this;

      var className = allprops.className,
          props = _objectWithoutProperties(allprops, ["className"]);

      if (props.value && this.state.showFloatingLabel) {
        className = [className, "mdc-textfield--upgraded"].join(" ");
      }

      return React.createElement(
        "div",
        { className: className, ref: function ref(control) {
            return _this5.control = control;
          } },
        props.multiline ? React.createElement("textarea", _extends({ className: "mdc-textfield__input" }, props)) : React.createElement("input", _extends({
          type: props.type || "text",
          className: "mdc-textfield__input"
        }, props)),
        props.label && this.state.showFloatingLabel && React.createElement(
          Label,
          {
            "for": props.id,
            className: props.value && "mdc-textfield__label--float-above"
          },
          props.label
        )
      );
    }
  }]);

  return TextfieldInput;
}(_MaterialComponent5.default);

/**
 * @prop fullwidth = false
 * @prop multiline = false
 * @prop dense = false
 * @prop disabled = false
 * @prop box = false
 * @prop type = 'text'
 * @prop value = ''
 * @prop label = ''
 * @prop helptext = ''
 * @prop helptextPersistent = false
 * @prop helptextValidationMsg = false
 */


var Textfield = function (_Component) {
  _inherits(Textfield, _Component);

  function Textfield() {
    _classCallCheck(this, Textfield);

    var _this6 = _possibleConstructorReturn(this, (Textfield.__proto__ || Object.getPrototypeOf(Textfield)).call(this));

    _this6.id = Textfield.uid();
    _this6.state = {
      showFloatingLabel: false
    };
    return _this6;
  }

  _createClass(Textfield, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setState({
        showFloatingLabel: true
      });
    }
  }, {
    key: "render",
    value: function render(allprops, _ref) {
      var showFloatingLabel = _ref.showFloatingLabel;

      var className = allprops.className,
          helptextPersistent = allprops.helptextPersistent,
          helptextValidationMsg = allprops.helptextValidationMsg,
          props = _objectWithoutProperties(allprops, ["className", "helptextPersistent", "helptextValidationMsg"]);

      var showDiv = props.helptext || props.label && !showFloatingLabel;

      if (showDiv && !props.id) {
        props.id = "tf-" + this.id;
      }

      // Helper text
      var helptextProps = {
        persistent: helptextPersistent,
        "validation-msg": helptextValidationMsg
      };

      return showDiv ? React.createElement(
        "div",
        { className: className },
        props.label && !showFloatingLabel && React.createElement(
          "label",
          { "for": props.id },
          props.cssLabel || props.label + ": "
        ),
        React.createElement(TextfieldInput, _extends({}, props, {
          "aria-controls": props.helptext && props.id + "-helptext"
        })),
        props.helptext && React.createElement(
          Helptext,
          _extends({ id: props.id + "-helptext" }, helptextProps),
          props.helptext
        )
      ) : React.createElement(TextfieldInput, _extends({}, props, { className: className }));
    }
  }], [{
    key: "uid",
    value: function uid() {
      if (!this.uidCounter) {
        this.uidCounter = 0;
      }
      return ++this.uidCounter;
    }
  }]);

  return Textfield;
}(_react.Component);

Textfield.Helptext = Helptext;

exports.default = Textfield;